package com.jiuqi.mde;

import com.jiuqi.util.RecIndex;

/* loaded from: com_jiuqi_mde.jar:com/jiuqi/mde/MDEIndex.class */
public final class MDEIndex extends RecIndex {
    public void genOrder(MDEDimValueSet dimValues) throws MDEException {
        genOrder(dimValues, false);
    }

    public void genOrder(MDEDimValueSet dimValues, boolean clearOrder) throws MDEException {
        int order = dimValues.dimensions().indexOf(MDEDimension.ORDER_NAME);
        if (order < 0) {
            return;
        }
        if (order != dimValues.dimensions().size() - 1) {
            throw new MDEException("顺序号维度必须是维度集合的最后一个");
        }
        if (dimValues.getValue(order) != null) {
            int index = -1;
            if (clearOrder) {
                index = search(dimValues);
            }
            if (index < 0) {
                return;
            }
        }
        dimValues.setValue(order, MDEDimension.MAX_INT_DIM_VALUE);
        int index2 = search(dimValues);
        if (index2 >= 0) {
            throw new MDEException("顺序号维度已达到最大值");
        }
        int index3 = (-1) - index2;
        if (index3 > 0 && dimValues.compareNoOrder(getKey(index3 - 1)) == 0) {
            MDEDimValueSet values = (MDEDimValueSet) getKey(index3 - 1);
            dimValues.setValue(order, new Integer(((Integer) values.getValue(order)).intValue() + 1));
        } else {
            dimValues.setValue(order, new Integer(1));
        }
    }

    public int findNoOrder(MDEDimValueSet dimValues) {
        int index = searchfirst(dimValues);
        if (index < 0) {
            int index2 = (-1) - index;
            if (index2 < size() && dimValues.compareNoOrder(getValue(index2)) == 0) {
                return index2;
            }
            if (index2 > 0 && dimValues.compareNoOrder(getValue(index2 - 1)) == 0) {
                return index2 - 1;
            }
            return -1;
        }
        return -1;
    }

    public int findFirstNoOrder(MDEDimValueSet dimValues) {
        MDEDimValueSet newValues = dimValues;
        int order = dimValues.dimensions().indexOf(MDEDimension.ORDER_NAME);
        if (order >= 0) {
            newValues = (MDEDimValueSet) dimValues.clone();
            newValues.setValue(order, (Object) null);
        }
        return findNoOrder(newValues);
    }
}
